#property indicator_chart_window

#include <Ovo/winapi/MT4NamedPipeServer.class.mqh>
#include <Ovo/MT4IndicatorManager.class.mqh>

input string SERVER_NAME = "mt4pipename";  // pipe name

void main() {
   manager.add(new RunServer());
}

struct Data : MT4Structure {
   ulong localmillis;   
   double ask;
   double bid;
   ulong serial;
};
/*
class RunServer: public MT4TimerRecuringListener {
   MT4NamedPipeServer* server;
   Data d;

public:
   ~RunServer() {
      deleteSafely(server);
   }
   RunServer() :MT4TimerRecuringListener(1000) {
      server = new MT4NamedPipeServer(SERVER_NAME);
      if (!server.createServer()) {
         ERROR("Server failed with code " + server.getLastError());
         PlaySound("Alert.wav");
         manager.initResult = INIT_FAILED;
      }
      d.serial =0;
   }
     
   
   void run() {
      DEBUG("server cycle");
      if (server.isOpen()) {
      
         //server.waitForClientConnection();
         d.ask = SymbolInfoDouble(_Symbol, SYMBOL_ASK);
         d.bid = SymbolInfoDouble(_Symbol, SYMBOL_BID);
         d.localmillis = GetTickCount();
         d.serial++;
         
         if (0 == server.writeStruct(d,sizeof(d))) {
            ERROR("Server Error " + server.getLastError());
         } else {
            DEBUG("written " + d.serial);
         }
      }
      else {
         ERROR("Server is closed.");
      }
      
   }   
};
*/

class RunServer: public MT4Indicator {
   MT4NamedPipeServer* server;
   Data d;

public:
   ~RunServer() {
      deleteSafely(server);
   }
   RunServer() : MT4Indicator() {
      server = new MT4NamedPipeServer(SERVER_NAME);
      if (!server.createServer()) {
         ERROR("Server failed with code " + server.getLastError());
         PlaySound("Alert.wav");
         manager.initResult = INIT_FAILED;
      }
      d.serial =0;
   }
     
   
   void calculate() {
      DEBUG("server cycle");
      if (server.isOpen()) {
      
         //server.waitForClientConnection();
         d.ask = SymbolInfoDouble(_Symbol, SYMBOL_ASK);
         d.bid = SymbolInfoDouble(_Symbol, SYMBOL_BID);
         d.localmillis = GetTickCount();
         d.serial++;
         
         if (0 == server.writeStruct(d,sizeof(d))) {
            ERROR("Server Error " + server.getLastError());
         } else {
            DEBUG("written " + d.serial);
         }
      }
      else {
         ERROR("Server is closed.");
      }
      
   }   
};